diff --git a/libstdc++-v3/include/std/expected b/libstdc++-v3/include/std/expected
index a796f0b6f27..a176d4c3a78 100644
--- a/libstdc++-v3/include/std/expected
+++ b/libstdc++-v3/include/std/expected
@@ -843,8 +843,12 @@ namespace __expected
 	and_then(_Fn&& __f) &
 	{
 	  using _Up = __expected::__result<_Fn, _Tp&>;
-	  static_assert(__expected::__is_expected<_Up>);
-	  static_assert(is_same_v<typename _Up::error_type, _Er>);
+	  static_assert(__expected::__is_expected<_Up>,
+			"the function passed to std::expected<T, E>::and_then "
+			"must return a std::expected");
+	  static_assert(is_same_v<typename _Up::error_type, _Er>,
+			"the function passed to std::expected<T, E>::and_then "
+			"must return a std::expected with the same error_type");
 
 	  if (has_value())
 	    return std::__invoke(std::forward<_Fn>(__f), _M_val);
@@ -857,8 +861,12 @@ namespace __expected
 	and_then(_Fn&& __f) const &
 	{
 	  using _Up = __expected::__result<_Fn, const _Tp&>;
-	  static_assert(__expected::__is_expected<_Up>);
-	  static_assert(is_same_v<typename _Up::error_type, _Er>);
+	  static_assert(__expected::__is_expected<_Up>,
+			"the function passed to std::expected<T, E>::and_then "
+			"must return a std::expected");
+	  static_assert(is_same_v<typename _Up::error_type, _Er>,
+			"the function passed to std::expected<T, E>::and_then "
+			"must return a std::expected with the same error_type");
 
 	  if (has_value())
 	    return std::__invoke(std::forward<_Fn>(__f), _M_val);
@@ -871,8 +879,12 @@ namespace __expected
 	and_then(_Fn&& __f) &&
 	{
 	  using _Up = __expected::__result<_Fn, _Tp&&>;
-	  static_assert(__expected::__is_expected<_Up>);
-	  static_assert(is_same_v<typename _Up::error_type, _Er>);
+	  static_assert(__expected::__is_expected<_Up>,
+			"the function passed to std::expected<T, E>::and_then "
+			"must return a std::expected");
+	  static_assert(is_same_v<typename _Up::error_type, _Er>,
+			"the function passed to std::expected<T, E>::and_then "
+			"must return a std::expected with the same error_type");
 
 	  if (has_value())
 	    return std::__invoke(std::forward<_Fn>(__f), std::move(_M_val));
@@ -886,8 +898,12 @@ namespace __expected
 	and_then(_Fn&& __f) const &&
 	{
 	  using _Up = __expected::__result<_Fn, const _Tp&&>;
-	  static_assert(__expected::__is_expected<_Up>);
-	  static_assert(is_same_v<typename _Up::error_type, _Er>);
+	  static_assert(__expected::__is_expected<_Up>,
+			"the function passed to std::expected<T, E>::and_then "
+			"must return a std::expected");
+	  static_assert(is_same_v<typename _Up::error_type, _Er>,
+			"the function passed to std::expected<T, E>::and_then "
+			"must return a std::expected with the same error_type");
 
 	  if (has_value())
 	    return std::__invoke(std::forward<_Fn>(__f), std::move(_M_val));
@@ -900,8 +916,12 @@ namespace __expected
 	or_else(_Fn&& __f) &
 	{
 	  using _Gr = __expected::__result<_Fn, _Er&>;
-	  static_assert(__expected::__is_expected<_Gr>);
-	  static_assert(is_same_v<typename _Gr::value_type, _Tp>);
+	  static_assert(__expected::__is_expected<_Gr>,
+			"the function passed to std::expected<T, E>::or_else "
+			"must return a std::expected");
+	  static_assert(is_same_v<typename _Gr::value_type, _Tp>,
+			"the function passed to std::expected<T, E>::or_else "
+			"must return a std::expected with the same value_type");
 
 	  if (has_value())
 	    return _Gr(in_place, _M_val);
@@ -914,8 +934,12 @@ namespace __expected
 	or_else(_Fn&& __f) const &
 	{
 	  using _Gr = __expected::__result<_Fn, const _Er&>;
-	  static_assert(__expected::__is_expected<_Gr>);
-	  static_assert(is_same_v<typename _Gr::value_type, _Tp>);
+	  static_assert(__expected::__is_expected<_Gr>,
+			"the function passed to std::expected<T, E>::or_else "
+			"must return a std::expected");
+	  static_assert(is_same_v<typename _Gr::value_type, _Tp>,
+			"the function passed to std::expected<T, E>::or_else "
+			"must return a std::expected with the same value_type");
 
 	  if (has_value())
 	    return _Gr(in_place, _M_val);
@@ -929,8 +953,12 @@ namespace __expected
 	or_else(_Fn&& __f) &&
 	{
 	  using _Gr = __expected::__result<_Fn, _Er&&>;
-	  static_assert(__expected::__is_expected<_Gr>);
-	  static_assert(is_same_v<typename _Gr::value_type, _Tp>);
+	  static_assert(__expected::__is_expected<_Gr>,
+			"the function passed to std::expected<T, E>::or_else "
+			"must return a std::expected");
+	  static_assert(is_same_v<typename _Gr::value_type, _Tp>,
+			"the function passed to std::expected<T, E>::or_else "
+			"must return a std::expected with the same value_type");
 
 	  if (has_value())
 	    return _Gr(in_place, std::move(_M_val));
@@ -943,8 +971,12 @@ namespace __expected
 	or_else(_Fn&& __f) const &&
 	{
 	  using _Gr = __expected::__result<_Fn, const _Er&&>;
-	  static_assert(__expected::__is_expected<_Gr>);
-	  static_assert(is_same_v<typename _Gr::value_type, _Tp>);
+	  static_assert(__expected::__is_expected<_Gr>,
+			"the function passed to std::expected<T, E>::or_else "
+			"must return a std::expected");
+	  static_assert(is_same_v<typename _Gr::value_type, _Tp>,
+			"the function passed to std::expected<T, E>::or_else "
+			"must return a std::expected with the same value_type");
 
 	  if (has_value())
 	    return _Gr(in_place, std::move(_M_val));
diff --git a/libstdc++-v3/include/std/optional b/libstdc++-v3/include/std/optional
index 4f75eb96f97..53450c760d9 100644
--- a/libstdc++-v3/include/std/optional
+++ b/libstdc++-v3/include/std/optional
@@ -1048,7 +1048,9 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
 	and_then(_Fn&& __f) &
 	{
 	  using _Up = remove_cvref_t<invoke_result_t<_Fn, _Tp&>>;
-	  static_assert(__is_optional_v<remove_cvref_t<_Up>>);
+	  static_assert(__is_optional_v<remove_cvref_t<_Up>>,
+			"the function passed to std::optional<T>::and_then "
+			"must return a std::optional");
 	  if (has_value())
 	    return std::__invoke(std::forward<_Fn>(__f), **this);
 	  else
@@ -1060,7 +1062,9 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
 	and_then(_Fn&& __f) const &
 	{
 	  using _Up = remove_cvref_t<invoke_result_t<_Fn, const _Tp&>>;
-	  static_assert(__is_optional_v<_Up>);
+	  static_assert(__is_optional_v<_Up>,
+			"the function passed to std::optional<T>::and_then "
+			"must return a std::optional");
 	  if (has_value())
 	    return std::__invoke(std::forward<_Fn>(__f), **this);
 	  else
@@ -1072,7 +1076,9 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
 	and_then(_Fn&& __f) &&
 	{
 	  using _Up = remove_cvref_t<invoke_result_t<_Fn, _Tp>>;
-	  static_assert(__is_optional_v<remove_cvref_t<_Up>>);
+	  static_assert(__is_optional_v<remove_cvref_t<_Up>>,
+			"the function passed to std::optional<T>::and_then "
+			"must return a std::optional");
 	  if (has_value())
 	    return std::__invoke(std::forward<_Fn>(__f), std::move(**this));
 	  else
@@ -1084,7 +1090,9 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
 	and_then(_Fn&& __f) const &&
 	{
 	  using _Up = remove_cvref_t<invoke_result_t<_Fn, const _Tp>>;
-	  static_assert(__is_optional_v<remove_cvref_t<_Up>>);
+	  static_assert(__is_optional_v<remove_cvref_t<_Up>>,
+			"the function passed to std::optional<T>::and_then "
+			"must return a std::optional");
 	  if (has_value())
 	    return std::__invoke(std::forward<_Fn>(__f), std::move(**this));
 	  else
@@ -1140,7 +1148,9 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
 	or_else(_Fn&& __f) const&
 	{
 	  using _Up = invoke_result_t<_Fn>;
-	  static_assert( is_same_v<remove_cvref_t<_Up>, optional> );
+	  static_assert(is_same_v<remove_cvref_t<_Up>, optional>,
+			"the function passed to std::optional<T>::or_else "
+			"must return a std::optional<T>");
 
 	  if (has_value())
 	    return *this;
@@ -1153,7 +1163,9 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
 	or_else(_Fn&& __f) &&
 	{
 	  using _Up = invoke_result_t<_Fn>;
-	  static_assert( is_same_v<remove_cvref_t<_Up>, optional> );
+	  static_assert(is_same_v<remove_cvref_t<_Up>, optional>,
+			"the function passed to std::optional<T>::or_else "
+			"must return a std::optional<T>");
 
 	  if (has_value())
 	    return std::move(*this);